// apt_dat.h
#ifndef _apt_dat_H_
#define _apt_dat_H_
#ifndef _WINDOWS_
#include <windows.h>
#endif
#ifndef	_fg_list_H_
#include "gshhs_list.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define  FG_MX_BUFF     2048
#define  FG_TYPE_MAX    8
#define  FG_ID_MAX      8
#define  FG_NAME_MAX    64
#define  FG_MAX_TOKENS  32
#define  FG_MAX_RWN      8

typedef enum
{
   FG_RUNWAY = 1,
   FG_TAXIWAY
}FG_RWY_TYPE;

//airports->add( last_apt_id, lon, lat, last_apt_elev,
//              last_apt_name, false );
typedef struct tagFGAPT {
   LE   link;
   double lat, lon, elev;
   char apt_id[FG_ID_MAX];
   char apt_name[FG_NAME_MAX];
} FGAPT, * PFGAPT;
//runways->add( last_apt_id, rwy_no, lon, lat, heading, length,
//           width, displ_thresh1, displ_thresh2,
//           stopway1, stopway2, lighting_flags, surface_code,
//           shoulder_code, marking_code, smoothness,
//           dist_remaining );
typedef struct tagFGRWY {
   LE link;
   FG_RWY_TYPE type;
   double lat, lon, heading, length, width;
   char rwy_id[FG_ID_MAX]; // this is airport ICAO ID
   char rwy_no[FG_MAX_RWN];
}FGRWY, *PFGRWY;

extern int FG_Data_Load_Data_File( char * pfile );
extern void Kill_Linked_Lists( void );
extern void Kill_List( void * pv );
extern void FG_Data_get_apts_in_bounds( double n, double s, double e, double w,
                                PLE phapts, PLE phrwys );
extern void Work_With_List( PGSINFO pgsi );
extern PLE Get_Airports_List( void );
extern PLE Get_Runways_List( void );

extern int bAdd_All_Taxi;
extern int iVerbal;

#ifdef __cplusplus
}
#endif
#endif //_apt_dat_H_
// eof - apt_dat.h
