// fix_dat.cxx

//#include "aptdat.h"
#include <string>
#include <iostream>
#include "gshhs_win.h"
#include "zlib.h"

#ifndef  NO_ADD_FG_DATA

using namespace std;

LE sFix_List = { &sFix_List, &sFix_List };

PLE Get_Fix_List( void )
{
   return &sFix_List;
}

void Del_Fix_List( void )
{
   PLE ph = Get_Fix_List();
   KillLList(ph);
}

PFIXES Add_Fix_List( PLE ph, double lat, double lon, const char * name )
{
   PFIXES pf = (PFIXES)MALLOC( sizeof(FIXES) );
   CHKMEM(pf,sizeof(FIXES));
   pf->lat = lat;
   pf->lon = lon;
   if( strlen(name) < MX_FIX_ID ) {
      strcpy(pf->id, name);
   } else {
      strncpy(pf->id, name, MX_FIX_ID);
      pf->id[MX_FIX_ID] = 0;
   }
   InsertTailList(ph, (PLE)pf);
   return pf;
}

PFIXES Add_Fix_Item( double lat, double lon, const char * name )
{
   PLE ph = Get_Fix_List();
   return Add_Fix_List( ph, lat, lon, name );
}

static char * tokens[FG_MAX_TOKENS];
static int tok_count;
static char buf[FG_MX_BUFF+8];
int Load_Fix_File( char * pfile )
{
   int   added_count = 0;
   unsigned int line_num = 0;
   gzFile gzf = gzopen(pfile, "rb");
   if( gzf ) {
      char * pb = buf;
      int    line_num = 0;
      char * cp;
      string name = "";
      string line = "";
      // skip first two lines
      cp = gzgets( gzf, pb, FG_MX_BUFF ); // int rd = gzread( gzf, buf, 2048 );
      cp = gzgets( gzf, pb, FG_MX_BUFF ); // int rd = gzread( gzf, buf, 2048 );
      cp = gzgets( gzf, pb, FG_MX_BUFF ); // int rd = gzread( gzf, buf, 2048 );
      do {
         size_t len = strlen(buf);
         while(len--) {
            if( buf[len] > ' ' )
               break;
            buf[len] = 0;
         }
         cp = buf;
         while( *cp && (*cp <= ' '))
            cp++;
         len = strlen(cp);
         line_num++;
         tok_count = 0;
         tokens[tok_count++] = cp;
         if( len > 0 ) {
            line = pb;
            while( *cp ) {
               while( *cp > ' ' ) cp++;
               if( *cp ) {
                  *cp = 0;
                  cp++;
                  while( *cp && (*cp <= ' ') ) cp++;
                  tokens[tok_count++] = cp;
                  if(tok_count >= FG_MAX_TOKENS )
                     break;
               }
            }
            double lat = atof( tokens[0] );
            if( lat >= 99.0 ) {
               if( iVerbal >= 2 ) {
                  sprtf( "End of list reached ...\n" );
               }
               break;
            }
            if( tok_count > 2 ) {
               double lon = atof( tokens[1] );
               name = tokens[2];
               Add_Fix_Item( lat, lon, name.c_str() );
               added_count++;
            }
         }  // got length
      } while(( cp = gzgets( gzf, pb, FG_MX_BUFF ) ) != NULL ); 
      gzclose(gzf);
      if( iVerbal >= 2 )
         sprtf( "Added %d FIXES to list ...\n", added_count );
   } else {
      sprtf( "WARNING: Failed to open %s file ...\n", pfile );
   }
   return added_count;
}

int Get_Fix_in_Bounds( double n, double s, double e, double w, PLE ph )
{
   int   found = 0;
   PLE   phf = Get_Fix_List();
   PLE   pn;
   double lat, lon;
   PFIXES pf, pf2;

   Traverse_List( phf, pn )
   {
      pf = (PFIXES)pn;
      lat = pf->lat;
      lon = pf->lon;
      if(( lat <= n )&&
         ( lat >= s )&&
         ( lon <= e )&&
         ( lon >= w )) {
         found++;
         pf2 = (PFIXES)MALLOC(sizeof(FIXES));
         CHKMEM(pf2,sizeof(FIXES));
         memcpy(pf2, pf, sizeof(FIXES));
         InsertTailList(ph, (PLE)pf2);
      }
   }
   return found;
}

#endif // #ifndef  NO_ADD_FG_DATA

// eof - fix_dat.cxx

